package org.dict.client;

import javax.swing.text.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.awt.*;
import java.awt.datatransfer.*;

public class DictionaryView implements Runnable, ActionListener {
    JFrame frame;
    JTextPane pane;
    JCheckBox mode;
    JTextField word;
    JTextField url;
    int delay = Integer.getInteger("delay", 20).intValue();
    Clipboard clipboard = java.awt.Toolkit.getDefaultToolkit().getSystemClipboard();
    String value = getClipboardText(clipboard);
    class ML extends MouseAdapter {
        public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == 2) {
                DictionaryView.this.lookup(DictionaryView.this.pane.getSelectedText());
            }
        }
    }
    class WL extends WindowAdapter {
        public void windowActivated(WindowEvent e) {
            DictionaryView.this.lookup();
        }
        public void windowClosing(WindowEvent e) {
            System.exit(0);
        }
    }
    class LinkFollower implements HyperlinkListener {

        private JEditorPane pane;

        public LinkFollower(JEditorPane pane) {
            this.pane = pane;
        }

        public void hyperlinkUpdate(HyperlinkEvent evt) {

            if (evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                try {
                    pane.setPage(evt.getURL());
                } catch (Exception e) {
                }
            }

        }

    }

/**
 * Insert the method's description here.
 * Creation date: (10.03.2002 23:39:54)
 */
public DictionaryView() {
	super();
	initialize();
}
	public void actionPerformed(ActionEvent e) {
		new Thread(this).start();
	}
private static String getClipboardText(Clipboard c) {
    Transferable content = c.getContents(null);
    if (content == null) {
        return null;
    }
    try {
        String s = (String) content.getTransferData(DataFlavor.stringFlavor);
		return s;
    } catch (Exception e) {
	    return null;
    }
}
private void initialize() {
	frame = new JFrame("Intelligent dictionary lookup");
    pane = new JTextPane();
    pane.setEditable(false);
    pane.setContentType("text/html");
    pane.addHyperlinkListener(new LinkFollower(pane));
    pane.addMouseListener(new ML());
    mode = new JCheckBox("Automatic", false);
    url = new JTextField("http://localhost:8080/dict?db=*&word=");
    word = new JTextField(15);
    word.addActionListener(this);
    JScrollPane scrollPane = new JScrollPane(pane);
    JPanel north = new JPanel();
    north.add(mode);
    JLabel urlLabel = new JLabel("Server");
    north.add(urlLabel);
    north.add(url);
    north.add(word);
    JPanel jp = new JPanel(new BorderLayout());
    jp.add(north, "North");
    jp.add(scrollPane, "Center");
    //jp.add(url, "South");
    frame.getContentPane().add(jp);
    frame.setSize(600, 400);
    frame.addWindowListener(new WL());
    frame.setVisible(true);
}
private void lookup() {
    String s = getClipboardText(clipboard);
    if (s != null && !s.equals(this.value)) {
        this.value = s;
        word.setText(s);
        new Thread(this).start();
    }
}
private void lookup(String s) {
	if (s == null || s.length() == 0 || s.length() > 25) return;
    frame.toFront();
    pane.setText("<html>Lookup word "+s+"<p>Please wait.</html>");
	try {
		pane.setPage(url.getText()+java.net.URLEncoder.encode(s));
	} catch (IOException e) {
		pane.setText("<html>"+e+"</html>");
	}
}
private void loop() {
    while (true) {
        try {
            Thread.sleep(delay);
        } catch (InterruptedException e) {
        }
        if (mode.isSelected()) {
            lookup();
        }
    }
}
public static void main(String[] args) {
    DictionaryView f = new DictionaryView();
    f.loop();
}
public void run() {
	lookup(word.getText());
}
}
