package org.dict.kernel;

/**
 * Insert the type's description here.
 * Creation date: (28.07.01 21:39:40)
 * @author: Administrator
 */
public interface IDatabase {
	public static final int STRATEGY_NONE = -1;
	public static final int STRATEGY_EXACT = 0;
	public static final int STRATEGY_PREFIX = 1;
	public static final int STRATEGY_NEAR = 2;
/**
 * This command will look up the specified word in the database
 */
String define(String word);
/**
 * This command will look up the word with specified index in the database
 */
IAnswer defineMatch(int pos, boolean define, int strategy);
/**
 * This command will look up the specified word in the database
 */
IAnswer defineMatch(String word, boolean define, int strategy);
/**
 * Show the database info
 */
String getDescription();
/**
 * Show the database info
 */
String getID();
/**
 * Show the database info
 */
String getName();
String getSourceLanguage();
String getTargetLanguage();
/**
 * This command searches an index for the dictionary, and reports words
 * which were found using a particular strategy, together with their positions.
 */
INeighbor[] match(String word, int strategy);
}
