package org.dict.server;

import java.io.*;
import org.dict.kernel.*;
/**
 * Insert the type's description here.
 * Creation date: (24.02.2002 14:44:28)
 * @author: 
 */
public class DictHTMLPrinter extends HTMLPrinter {
/**
 * HTMLFormat constructor comment.
 */
public DictHTMLPrinter() {
	super();
}
public void printAnswer(
    IRequest req,
    IAnswer a,
    boolean matches,
    PrintWriter out)
    throws IOException {
    out.print("<h3>Reply from: ");
    out.print(a.getDatabase().getName());
    out.println("</h3>\n");
    String def = a.getDefinition();
    String uri = req.getRequestURI();
    String base = uri + "?db=" + a.getDatabase().getID() + "&word=";
    String posBase = uri + "?db=" + a.getDatabase().getID() + "&pos=";
    if (def != null) {
        out.println("<pre>");
        String lk = makeLink(def, base);
        out.println(lk);
        out.println("</pre>");
    } else {
        out.println("No definition found");
    }
    if (matches) {
        StringBuffer sb = new StringBuffer("Neighboring entries: \n");
        INeighbor[] neighbors = a.getMatches();
        for (int k = 0; k < neighbors.length; k++) {
            appendLink(neighbors[k].getKey(), posBase, neighbors[k].getPosition(), sb);
            sb.append(" | \n");
        }
        out.println(sb);
    }
}
public void printForm(IDictEngine e, IRequest req, PrintWriter out) throws IOException {
	//printDefaultForm(e, req, out);
}
}
