package org.dict.server;

import org.dict.kernel.*;
import org.dict.kernel.IDictEngine;
import javax.servlet.http.*;

public class DictServlet extends HttpServlet {
	org.dict.kernel.IDictEngine fEngine;
/**
 * WordNetServlet constructor comment.
 */
public DictServlet() {
	super();
}
protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws javax.servlet.ServletException, java.io.IOException {
	handleRequest(req, res);
}
protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws javax.servlet.ServletException, java.io.IOException {
	handleRequest(req, res);
}
/**
 * handleRequest method comment.
 */
protected void handleRequest(HttpServletRequest request, HttpServletResponse res) throws javax.servlet.ServletException, java.io.IOException {
	String enc = getOutputEncoding(request);
	res.setContentType("text/html; charset="+enc);
	java.io.PrintWriter out = res.getWriter();
	IRequest req = new SimpleRequest(request.getRequestURI(), request.getQueryString());
	IAnswer[] arr = fEngine.lookup(req);
	HTMLPrinter.printAnswers(fEngine, req, arr, true, out);
}
public void init() {
	String cfg = getInitParameter("config");
	if (!new java.io.File(cfg).isAbsolute()) {
		String base = getServletContext().getRealPath("/");
		cfg = new java.io.File(base, cfg).getAbsolutePath();
	}
	fEngine = getEngine(cfg);
}

protected IDictEngine getEngine(String cfg) {
	return org.dict.server.DatabaseFactory.getEngine(cfg);
}

protected String getOutputEncoding(HttpServletRequest req) {
	return "UTF-8";
}
}
