package org.dict.server;

import java.io.*;
import org.dict.kernel.*;
//import java.util.Hashtable;
/**
 * Insert the type's description here.
 * Creation date: (24.02.2002 14:44:28)
 * @author: 
 */
public abstract class HTMLPrinter extends AnswerPrinter {
/**
 * HTMLFormat constructor comment.
 */
public HTMLPrinter() {
	super();
}
public static void appendLink(String s, String base, int pos, StringBuffer sb) {
	sb.append("<a href=\"");
	sb.append(base);
	sb.append(pos);
	sb.append("\">");
	sb.append(s);
	sb.append("</a>");
}
public static void appendLink(String s, String base, StringBuffer sb) {
	String str = s;
	try {
		str = new String(s.getBytes("UTF-8"));
	} catch (Throwable t) {}
	sb.append("<a href=\"");
	sb.append(base);
	sb.append(java.net.URLEncoder.encode(str));
	sb.append("\">");
	sb.append(s);
	sb.append("</a>");
}
protected static String getOption(String db, String[] ids) {
	for (int i = 0; i < ids.length; i++){
		if (db.equals(ids[i])) return "\""+db+"\" selected";
	}
	return "\""+db+"\"";
}
public static String makeLink(String def, String base) {
	if (def == null) return "";
	String delim = "{}";
	java.util.StringTokenizer st = new java.util.StringTokenizer(def, delim, true);
	StringBuffer sb = new StringBuffer(def.length());
	String s;
	while (st.hasMoreTokens()) {
		s = st.nextToken();
		if (s.equals("}")) {
			continue;
		}
		if (s.equals("{")) {
			String tok = st.nextToken();
			s = removeSpaces(tok);
			if (tok.indexOf('\n') >= 0) {
				sb.append("\n\t");
			}
			appendLink(s, base, sb);
		}
		else {
			sb.append(s);
		}
	}
	return sb.toString();
}
public static void printAnswers(IDictEngine e, IRequest req, IAnswer[] a, boolean matches, PrintWriter out) throws IOException {
	out.println("<html>");
	out.println("<head>");
	out.println("<title>Dictionary lookup</title>");
	out.println("<STYLE type=text/css>");
	out.println("a:link {color: #0066cc; TEXT-DECORATION: none}");
	out.println("a:visited {color: #0066cc; TEXT-DECORATION: none}");
	out.println("</STYLE>");
	out.println("</head>");
	out.println("<body>");
	if (a == null || a.length == 0) {
		out.println("<h1><a href=\"index.html\">Please go to main page</a></h1>");;
		out.println("</body></html>");
		return;
	}
	for (int i = 0; i < a.length; i++){
		AnswerPrinter p = getPrinter(a[i].getDatabase().getID(), "text/html");
		if (i == 0) {
			p.printForm(e, req, out);
		}
		p.printAnswer(req, a[i], matches, out);
	}
	out.println("</body></html>");
}
public static void printDefaultForm(IDictEngine e, IRequest req, PrintWriter out) throws IOException {
	String[] ids = req.getParameterValues("db");
	if (ids == null || ids.length == 0) {
		ids = new String[]{"*"};
	}
	String uri = req.getRequestURI();
	IDatabase[] dbs = e.getDatabases();
	out.println("Please enter the word or phrase to look for!");
	out.println("<FORM METHOD=GET action=\""+uri+"\">");
	out.println("<INPUT SIZE=20 NAME=\"word\">");
	out.println("<select name=\"db\">");
	out.println("  <option value="+getOption("*", ids)+">Any");
	out.println("  <option value="+getOption("!", ids)+">First match");
	for (int i = 0; i < dbs.length; i++){
		String db = dbs[i].getName();
		out.println("  <option value="+getOption(dbs[i].getID(), ids)+">"+db);
	}
	out.println("<input type=\"SUBMIT\" value=\"Lookup\">");
	out.println("<input type=\"reset\" value=\"Clear\">");
	out.println("</select>");
	out.println("</FORM>");
}
public static String removeSpaces(String s) {
	java.util.StringTokenizer st = new java.util.StringTokenizer(s, " \t\n\r\f", false);
	StringBuffer sb = new StringBuffer(s.length());
	while (st.hasMoreTokens()) {
		sb.append(st.nextToken()).append(' ');
	}
	return sb.toString().trim();
}
}
