package org.dict.server;

import java.io.*;
import org.dict.kernel.*;
/**
 * Insert the type's description here.
 * Creation date: (11.03.2002 16:28:49)
 * @author: 
 */
public class PlainPrinter extends AnswerPrinter {
/**
 * PlainPrinter constructor comment.
 */
public PlainPrinter() {
	super();
}
public void printAnswer(IRequest req, IAnswer a, PrintWriter out) throws IOException {
	out.println(a.getDefinition());
}
public void printAnswer(IRequest req, IAnswer a, boolean matches, PrintWriter out) throws IOException {
	if (a.getDefinition() != null) {
		out.println(a.getDefinition());
	} else {
		out.println("No definition found");
	}
	out.println();
	if (matches) {
		printNeighbors(a, out);
	}
}
public static void printAnswers(IDictEngine e, IRequest req, IAnswer[] a, boolean matches, PrintWriter out) throws IOException {
	if (a == null || a.length == 0) {
		out.println("Nothing found");
	}
	out.println("Search results for "+req.getParameter("word"));
	out.println();
	for (int i = 0; i < a.length; i++){
		out.println("Reply from "+a[i].getDatabase().getName());
		out.println();
		AnswerPrinter p = getPrinter(a[i].getDatabase().getID(), "text/plain");
		p.printAnswer(req, a[i], matches, out);
	}
}
private static void printNeighbors(IAnswer a, PrintWriter out)
    throws IOException {
    out.println("Neighboring entries:");
    INeighbor[] neighbors = a.getMatches();
    for (int k = 0; k < neighbors.length; k++) {
        String sep = k == 10 ? "\n" : " | ";
        out.print(neighbors[k].getKey() + sep);
    }
    out.println('\n');
}
}
